<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php

class Memcached {
	protected $mc_servers = array();
	protected $mc_servers_count;

	private static $instance = false;

	static function getInstance(){
    	$servers = array(); //_Config::$memcache_servers;
    	self::$instance || self::$instance = new Memcached($servers);
    	return self::$instance;
	}

	protected function __construct(array $servers){
    	if (!$servers){
        	trigger_error('No memcache servers to connect',E_USER_WARNING);
    	}
		
    	for ($i = 0, $n = count($servers); $i < $n; ++$i){
        	($con = memcache_pconnect(key($servers[$i]), current($servers[$i])) )&& $this->mc_servers[] = $con;
		}
		
		$this->mc_servers_count = count($this->mc_servers);
		if (!$this->mc_servers_count){
        	$this->mc_servers[0]=null;
		}
	}

	protected function getMemcacheLink($key){
    	if ($this->mc_servers_count <2){
			return $this->mc_servers[0];
		}
		return $this->mc_servers[(crc32($key) & 0x7fffffff)%$this->mc_servers_count];
	}

	static function flush() {
    	$x = self::getInstance()->mc_servers_count;
    	for ($i = 0; $i < $x; ++$i){
        	$a = self::getInstance()->mc_servers[$i];
        	self::getInstance()->mc_servers[$i]->flush();
    	}
	}

	static function get($key) {
    	return self::getInstance()->getMemcacheLink($key)->get($key);
	}

	static function set($key, $var, $compress=0, $expire=0) {
    	return self::getInstance()->getMemcacheLink($key)->set($key, $var, $compress?MEMCACHE_COMPRESSED:null, $expire);
	}

	static function add($key, $var, $compress=0, $expire=0) {
    	return self::getInstance()->getMemcacheLink($key)->add($key, $var, $compress?MEMCACHE_COMPRESSED:null, $expire);
	}

	static function replace($key, $var, $compress=0, $expire=0) {
    	return self::getInstance()->getMemcacheLink($key)->replace($key, $var, $compress?MEMCACHE_COMPRESSED:null, $expire);
	}

	static function delete($key, $timeout=0) {
    	return self::getInstance()->getMemcacheLink($key)->delete($key, $timeout);
	}

	static function increment($key, $value=1) {
    	return self::getInstance()->getMemcacheLink($key)->increment($key, $value);
	}

	static function decrement($key, $value=1) {
    	return self::getInstance()->getMemcacheLink($key)->decrement($key, $value);
	}
}
?>